/*
 * Rock-Paper-Scissors.c
 *
 * Created: 1/9/2016 11:56:53 AM
 * Author : ppotty
 */ 

#define F_CPU 10000000

#include <avr/io.h>
#include <util/delay.h>

void adc_init() {
	ADMUX = 0x06;
	ADCSRA = 0x85;
	DIDR0 = (1 << ADC6D);
	ADCSRA |= (1 << ADSC);
}

uint32_t get_rand_seed() {
	char seed_byte = 0;
	uint32_t seed = 0;
	
	while (seed_byte < 4) {
		while (ADCSRA & (1 << ADSC));
		seed |= (ADCL << (seed_byte * 8));
		seed_byte++;

	}
	return seed;
}

int main(void) {
    uint32_t rand;
	int hold = 0;
	
	DDRA |= (1 << PA3);	//Rock
	DDRA |= (1 << PA4); //Paper
	DDRA |= (1 << PA5); //Scissors
	
	adc_init();
	rand = get_rand_seed();
	
    while (1) {
		if (PINA & (1 << PA7)) {
			if (!hold) {
				rand ^= rand << 13;		//Xorshift RNG
				rand ^= rand >> 17;
				rand ^= rand << 5;
				
				if (rand < 1431655765) {
					PORTA |= (1 << PA3);
				}
				if (rand > 1431655765) {
					if (rand < 2863311530) {
						PORTA |= (1 << PA4);
					}
				}
				if (rand > 2863311530) {
					PORTA |= (1 << PA5);
				}
				hold = 1;
			}
		}
		else {
			PORTA &= 0xC7;
			hold = 0;
		}
    }
}

